/* ////////////////////////////////////////////////////////////////////////////
** File:      PirInterface.pde
*/                                  
 unsigned char  Ver[] = "PirInterface 1.3.1Guiott 06-11"; // 30+1 char
/* Author:    Guido Ottaviani-->guido@guiott.com<--
** Description: interface between PIR sensors and Isadora presentation program
**               using serial interface
**
-------------------------------------------------------------------------------
Copyright 2010 Guido Ottaviani
guido@guiott.com

    PirInterface.pde is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    PirInterface.pde is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with PirInterface.pde.  If not, see <http://www.gnu.org/licenses/>.
-------------------------------------------------------------------------------      
/////////////////////////////////////////////////////////////////////////////*/

#include <Metro.h>
#include <Bounce.h>

const byte Led[8] = {10,11,12,13,14,15,16,17};// Led pin definition
const byte Pir[8] = {2,3,4,5,6,7,8,9};        // Pir pin definition
int bPir[8];                                  // Pir Bounce current values
int bPirPrev[8];                              // Pir Bounce previous values
#define B_MS 300                              // debounce time
#define B_TIME 1000                           // contact duration time********
int PrevPir=8;

#define BLINK_ON 50             // HeartBeat Blink On time
#define BLINK_OFF 950           // HeartBeat Blink Off time
#define BLINK_ALRT 100          // HeartBeat Blink Alert time
boolean LedStat = false;
boolean HbFlag = true;          // HeartBeat On/Off

int PIR_NUM=8;                  // number of sensors***************************

int LedCount=PIR_NUM;
int i; // generic counter

Metro BlinkCycle = Metro(BLINK_OFF);  // LED blink cycle

Bounce BouncePir0 = Bounce( Pir[0], B_MS );
Bounce BouncePir1 = Bounce( Pir[1], B_MS );
Bounce BouncePir2 = Bounce( Pir[2], B_MS );
Bounce BouncePir3 = Bounce( Pir[3], B_MS );
Bounce BouncePir4 = Bounce( Pir[4], B_MS );
Bounce BouncePir5 = Bounce( Pir[5], B_MS );
Bounce BouncePir6 = Bounce( Pir[6], B_MS );
Bounce BouncePir7 = Bounce( Pir[7], B_MS );

//-----------------------------------------------------------------------------      
void setup()
{
  Serial.begin(9600); 
  PIR_NUM = PIR_NUM - 1;
  
  for (i=0; i<8;i++)
  {
    pinMode(Led[i], OUTPUT);
  }
  
  for (i=0; i<8;i++)
  {
    pinMode(Pir[i], INPUT);
    digitalWrite(Pir[i], HIGH);  // set internal 20KOhm pullup resistor
  }
  LedTest();
  delay(500);
}

//-----------------------------------------------------------------------------      
void loop()
{  
  PirControl();
  if (BlinkCycle.check() == 1 && HbFlag ) {HeartBeat();}  // Led blink
}

