//-----------------------------------------------------------------------------      
void HeartBeat (void)
{ // regular blink as heart beat signal
  if (!LedStat)
  {
    LedStat = true;
    BlinkCycle.interval(BLINK_ON);  // change to ON period
    digitalWrite(Led[LedCount],LOW);
    LedCount++;
    if (LedCount>PIR_NUM) 
    {
      LedCount=0;
      PrevPir=PIR_NUM+1;
    }
    digitalWrite(Led[LedCount],HIGH);
  }
  else
  {
    LedStat = false;
    BlinkCycle.interval(BLINK_OFF);  // change to OFF period
    digitalWrite(Led[LedCount],LOW);
  }
}

//-----------------------------------------------------------------------------      
void SerialOut(byte Led)
{// send PIR # data on serial port
  Serial.print("PIR");
  Serial.print(48+Led, BYTE); // ASCII converted number
  Serial.print(13, BYTE);
//  Serial.print(10, BYTE);
}

//-----------------------------------------------------------------------------      
void LedOn(int LedN)
{// Stops the heartbeat and lights up the specific led
  HbFlag = false;
  digitalWrite(Led[LedN],HIGH);
  LedCount=PIR_NUM;
}

//-----------------------------------------------------------------------------      
void LedOff(int LedN)
{// Re-starts the heartbeat and switches off the specific led
  HbFlag = true;
  digitalWrite(Led[LedN],LOW);
}

//-----------------------------------------------------------------------------      
void BounceUpdatePir(void)
{// after debounce time, the contact must on or off for B_TIME before switching
  // highest the number greater the priority
 
  BouncePir7.update();
  bPir[7] = BouncePir7.read();
  if (bPir[7] !=  bPirPrev[7] && BouncePir7.duration() > B_TIME)
  {
    bPirPrev[7] = bPir[7];
  }
  
  BouncePir6.update();
  bPir[6] = BouncePir6.read();
  if (bPir[6] !=  bPirPrev[6] && BouncePir6.duration() > B_TIME)
  {
    bPirPrev[6] = bPir[6];
  }
  
  BouncePir5.update();
  bPir[5] = BouncePir5.read();
  if (bPir[5] !=  bPirPrev[5] && BouncePir5.duration() > B_TIME)
  {
    bPirPrev[5] = bPir[5];
  }
 
  BouncePir4.update();
  bPir[4] = BouncePir4.read();
  if (bPir[4] !=  bPirPrev[4] && BouncePir4.duration() > B_TIME)
  {
    bPirPrev[4] = bPir[4];
  }
  
  BouncePir3.update();
  bPir[3] = BouncePir3.read();
  if (bPir[3] !=  bPirPrev[3] && BouncePir3.duration() > B_TIME)
  {
    bPirPrev[3] = bPir[3];
  }
  
  BouncePir2.update();
  bPir[2] = BouncePir2.read();
  if (bPir[2] !=  bPirPrev[2] && BouncePir2.duration() > B_TIME)
  {
    bPirPrev[2] = bPir[2];
  }
  
  BouncePir1.update();
  bPir[1] = BouncePir1.read();
  if (bPir[1] !=  bPirPrev[1] && BouncePir1.duration() > B_TIME)
  {
    bPirPrev[1] = bPir[1];
  }
  
  BouncePir0.update();
  bPir[0] = BouncePir0.read();
  if (bPir[0] !=  bPirPrev[0] && BouncePir0.duration() > B_TIME)
  {
    bPirPrev[0] = bPir[0];
  }
}

//-----------------------------------------------------------------------------      
void PirControl(void)
{// only the PIR with the highest number is considered active
  BounceUpdatePir();  
  LedOff(PrevPir);
  for (i=PIR_NUM; i>=0; i--)
  {
    if(bPirPrev[i])
    {
      LedOn(i);
      if (i!= PrevPir)
      {// if changed send out command 
        PrevPir=i;
        SerialOut(i+1);
      }
      break;
    }
  }
}
